#include <stddef.h>
#include <stdlib.h>
#include "aa.h"
#include "intlist.h"
#include "tally.h"
#include "counts.h"

static Vector_T
Counts_fromTally_new (Tally_T tally, Vector_T weights) {
  Intlist_T s;
  int aa_index;
  double wt;
  Vector_T counts;

  counts = Vector_new(NAT_AAS);
  for ( ; tally; tally = Tally_rest(tally)) {
    aa_index = AA_acd_index(Tally_aa(tally));
    for (s = Tally_sequences(tally); s; s = s->rest) {
      wt = Vector_get(counts,aa_index);
      wt += Vector_get(weights,s->first);
      Vector_put(counts,aa_index,wt); 
    }
  }
  return counts;
}

Matrix_T
Counts_fromBlock_new (Block_T block, Vector_T weights) {
  Vector_T counts;
  Tally_T tally;
  int pos, positions;
  Matrix_T count_matrix;

  positions = Block_positions(block);
  count_matrix = Matrix_new(positions,NAT_AAS);
  for (pos = 0; pos < positions; ++pos) {
    tally = Block_get(block,pos);
    counts = Counts_fromTally_new(tally,weights);
    Matrix_put(count_matrix,pos,counts);
  }
  return count_matrix;
}

