#ifndef DISTVECTOR_INCLUDED
#define DISTVECTOR_INCLUDED
#include "frequencies.h"
#include "dist.h"

#define T Distvector_T
typedef struct T *T;

extern T
Distvector_init (int maxorder);
extern T
Distvector_new (int pos, int maxorder, int min_score, int max_score);
extern void
Distvector_free (T *distvector);
extern void
Distvector_print (T distvector);
extern T
Distvector_update (T old, int pos, int maxorder, Frequencies_T frequencies,
		   int **profile, int *min_scores, int *max_scores);
extern Dist_T
Distvector_compress (T distvector);
extern double
Distvector_check (T distvector);

#undef T
#endif
